"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var react_testing_library_1 = require("react-testing-library");
var history_1 = require("history");
var lodash_1 = require("lodash");
var props_interceptor_1 = require("props-interceptor");
var qs_1 = __importDefault(require("qs"));
var query_string_1 = __importDefault(require("query-string"));
var react_1 = __importDefault(require("react"));
var withUrlState_1 = require("./withUrlState");
var UrlBasedControls = function (props) { return (react_1.default.createElement("div", null,
    react_1.default.createElement("div", { "data-testid": "currentAnimal" }, props.urlState.animal),
    react_1.default.createElement("div", { "data-testid": "currentColor" }, props.urlState.color),
    react_1.default.createElement("button", { "data-testid": "Green", onClick: function () { return props.setUrlState(__assign({}, props.urlState, { color: 'Green' })); } }, "Green"),
    react_1.default.createElement("button", { "data-testid": "Red", onClick: function () { return props.setUrlState(__assign({}, props.urlState, { color: 'Red' })); } }, "Red"))); };
// See https://github.com/kentcdodds/react-testing-library/issues/215 for why this is necessary
var effectfulRender = function (jsx) {
    var wrapper = react_testing_library_1.render(jsx);
    wrapper.rerender(jsx);
    return wrapper;
};
var parseQueryString = function (str) { return qs_1.default.parse(str, { ignoreQueryPrefix: true }); };
describe('useUrlState', function () {
    afterEach(react_testing_library_1.cleanup);
    var testHistory = null;
    beforeEach(function () {
        testHistory = history_1.createBrowserHistory();
        var newLocation = __assign({}, testHistory.location, { search: qs_1.default.stringify({ color: 'Blue' }) });
        testHistory.replace(newLocation);
    });
    it('sanity checks the before hook', function () {
        expect(parseQueryString(testHistory.location.search)).toEqual({ color: 'Blue' });
    });
    it('will not override any params which are already provided in the query string', function () { return __awaiter(_this, void 0, void 0, function () {
        var UrlConnectedControls, wrapper;
        return __generator(this, function (_a) {
            UrlConnectedControls = function () {
                var _a = withUrlState_1.useUrlState({ color: 'Red' }, { history: testHistory }), urlState = _a[0], setUrlState = _a[1];
                return react_1.default.createElement(UrlBasedControls, { setUrlState: setUrlState, urlState: urlState });
            };
            wrapper = effectfulRender(react_1.default.createElement(UrlConnectedControls, null));
            expect(parseQueryString(window.location.search)).toEqual({ color: 'Blue' });
            expect(wrapper.getByTestId('currentColor').textContent).toBe('Blue');
            return [2 /*return*/];
        });
    }); });
    it('will append any additional any params which are not provided in the querystring', function () {
        var UrlConnectedControls = function () {
            var _a = withUrlState_1.useUrlState({ animal: 'Ant', color: 'Blue' }, { history: testHistory }), urlState = _a[0], setUrlState = _a[1];
            return react_1.default.createElement(UrlBasedControls, { urlState: urlState, setUrlState: setUrlState });
        };
        var wrapper = effectfulRender(react_1.default.createElement(UrlConnectedControls, null));
        expect(parseQueryString(testHistory.location.search)).toEqual({
            animal: 'Ant',
            color: 'Blue',
        });
        expect(wrapper.getByTestId('currentAnimal').textContent).toBe('Ant');
        expect(wrapper.getByTestId('currentColor').textContent).toBe('Blue');
    });
    it('sets the url with the initial state', function () {
        var UrlConnectedControls = function () {
            var _a = withUrlState_1.useUrlState({ animal: 'Ant', color: 'Blue' }, { history: testHistory }), urlState = _a[0], setUrlState = _a[1];
            return react_1.default.createElement(UrlBasedControls, { setUrlState: setUrlState, urlState: urlState });
        };
        effectfulRender(react_1.default.createElement(UrlConnectedControls, null));
        expect(parseQueryString(testHistory.location.search)).toEqual({
            animal: 'Ant',
            color: 'Blue',
        });
    });
    it('provides the current urls state to the wrapped component', function () {
        var UrlConnectedControls = function () {
            var _a = withUrlState_1.useUrlState({ animal: 'Ant', color: 'Blue' }, { history: testHistory }), urlState = _a[0], setUrlState = _a[1];
            return react_1.default.createElement(UrlBasedControls, { setUrlState: setUrlState, urlState: urlState });
        };
        var wrapper = react_testing_library_1.render(react_1.default.createElement(UrlConnectedControls, null));
        expect(wrapper.getByTestId('currentAnimal').textContent).toBe('Ant');
        expect(wrapper.getByTestId('currentColor').textContent).toBe('Blue');
    });
    it('updates the url when the wrapped component updates the state', function () {
        var UrlConnectedControls = function () {
            var _a = withUrlState_1.useUrlState({ animal: 'Ant', color: 'Blue' }, { history: testHistory }), urlState = _a[0], setUrlState = _a[1];
            return react_1.default.createElement(UrlBasedControls, { setUrlState: setUrlState, urlState: urlState });
        };
        var wrapper = effectfulRender(react_1.default.createElement(UrlConnectedControls, null));
        expect(wrapper.getByTestId('currentAnimal').textContent).toBe('Ant');
        expect(wrapper.getByTestId('currentColor').textContent).toBe('Blue');
        expect(parseQueryString(testHistory.location.search)).toEqual({
            animal: 'Ant',
            color: 'Blue',
        });
        react_testing_library_1.fireEvent.click(wrapper.getByTestId('Green'));
        wrapper.rerender(react_1.default.createElement(UrlConnectedControls, null));
        expect(wrapper.getByTestId('currentAnimal').textContent).toBe('Ant');
        expect(wrapper.getByTestId('currentColor').textContent).toBe('Green');
        expect(parseQueryString(testHistory.location.search)).toEqual({
            animal: 'Ant',
            color: 'Green',
        });
    });
    describe('config', function () {
        describe('shouldPushState', function () {
            it('takes a predicate used to decide if the new search is pushed or replaced', function () {
                var propSpy = jest.fn();
                var memoryHistory = history_1.createMemoryHistory();
                var hocConfig = {
                    history: memoryHistory,
                    shouldPushState: function () { return function (n, p) { return true; }; },
                };
                var UrlConnectedControls = lodash_1.flow(props_interceptor_1.interceptor(function (props) { return propSpy(props); }), withUrlState_1.withUrlState(function () { return ({ color: 'Red' }); }, hocConfig))(UrlBasedControls);
                effectfulRender(react_1.default.createElement(UrlConnectedControls, null));
                var setUrlState = propSpy.mock.calls[0][0].setUrlState;
                setUrlState({ color: 'Green' });
                setUrlState({ color: 'Blue' });
                expect(memoryHistory.action).toBe('PUSH');
                expect(memoryHistory.entries.length).toBe(3);
            });
            it('allows comparison of the *parsed* state to be applied and the current state', function () {
                var shouldPushState = jest.fn();
                var capturedProps = [];
                var UrlConnectedControls = lodash_1.flow(props_interceptor_1.interceptor(function (props) { return capturedProps.push(props); }), withUrlState_1.withUrlState(function () { return ({ animal: 'Bat', color: 'blue' }); }, {
                    history: testHistory,
                    shouldPushState: function () { return shouldPushState; },
                }))(UrlBasedControls);
                effectfulRender(react_1.default.createElement(UrlConnectedControls, null));
                var _a = capturedProps[0], setUrlState = _a.setUrlState, urlState = _a.urlState;
                var nextState = { animal: 'Cat', color: 'cyan' };
                setUrlState(nextState);
                expect(shouldPushState).toBeCalledWith(nextState, urlState);
            });
        });
        describe('history', function () {
            it('can accept a history provider to use alternate implementations', function () {
                var memoryHistory = history_1.createMemoryHistory();
                var enhance = withUrlState_1.withUrlState(function () { return ({ color: 'Red' }); }, {
                    history: memoryHistory,
                });
                var UrlConnectedControls = enhance(UrlBasedControls);
                effectfulRender(react_1.default.createElement(UrlConnectedControls, null));
                expect(parseQueryString(memoryHistory.location.search)).toEqual({ color: 'Red' });
                expect(memoryHistory.entries.length).toBe(1);
            });
            it('calls the unsubscribe of the HistoryAdapter when the component is unmounted', function () {
                var unsubscribeCallback = jest.fn();
                var unsubscribeHistory = {
                    location: {
                        pathname: 'pathname',
                        search: '?search',
                        hash: '',
                    },
                    listen: function (listener) { return unsubscribeCallback; },
                    push: function (location) { },
                    replace: function (location) { },
                };
                var enhance = withUrlState_1.withUrlState(function () { return ({ animal: 'Ant', color: 'Blue' }); }, {
                    history: unsubscribeHistory,
                });
                var UrlConnectedControls = enhance(UrlBasedControls);
                var unmount = react_testing_library_1.render(react_1.default.createElement(UrlConnectedControls, null)).unmount;
                unmount();
                expect(unsubscribeCallback).toHaveBeenCalled();
            });
        });
        describe('serialisation', function () {
            it('accepts a custom parse and stringify', function () {
                var config = {
                    history: testHistory,
                    serialisation: {
                        parse: query_string_1.default.parse,
                        stringify: query_string_1.default.stringify,
                    },
                };
                var UrlConnectedControls = withUrlState_1.withUrlState(function () { return ({ color: 'Red' }); }, config)(UrlBasedControls);
                expect(parseQueryString(testHistory.location.search)).toEqual({ color: 'Blue' });
                var wrapper = react_testing_library_1.render(react_1.default.createElement(UrlConnectedControls, null));
                expect(parseQueryString(testHistory.location.search)).toEqual({ color: 'Blue' });
                expect(wrapper.getByTestId('currentColor').textContent).toBe('Blue');
            });
            it('supports complex serialisation workflows', function () {
                var defaultSort = 'BEST_MATCH';
                var defaultQueryParameters = {
                    q: 'Winchester',
                    page: 1,
                    sort: defaultSort,
                };
                var sortAlphabeticalWithQFirst = function (a, b) {
                    if (a < b || a === 'q') {
                        return -1;
                    }
                    else if (a > b || b === 'q') {
                        return 1;
                    }
                    else {
                        return 0;
                    }
                };
                var config = {
                    history: testHistory,
                    serialisation: {
                        parse: function (queryStr) {
                            var stringyParams = qs_1.default.parse(queryStr, { ignoreQueryPrefix: true });
                            if (typeof stringyParams === 'object') {
                                var pageFromQuery = typeof stringyParams.page === 'string'
                                    ? parseInt(stringyParams.page, 10)
                                    : undefined;
                                var maxPriceAsNumber = parseInt(stringyParams.max_price || '', 10);
                                var minPriceAsNumber = parseInt(stringyParams.min_price || '', 10);
                                return {
                                    q: stringyParams.q || defaultQueryParameters.q,
                                    page: pageFromQuery !== undefined && !isNaN(pageFromQuery)
                                        ? pageFromQuery
                                        : 1,
                                    sort: stringyParams.sort || defaultSort,
                                    max_price: !isNaN(maxPriceAsNumber) ? maxPriceAsNumber : undefined,
                                    min_price: !isNaN(minPriceAsNumber) ? minPriceAsNumber : undefined,
                                };
                            }
                            else {
                                return defaultQueryParameters;
                            }
                        },
                        stringify: function (state) {
                            var max_price = state.max_price, min_price = state.min_price;
                            var minAndMaxPrice = min_price && max_price
                                ? { max_price: max_price, min_price: min_price }
                                : { max_price: undefined, min_price: undefined };
                            var filteredState = __assign({ q: state.q ? state.q : defaultQueryParameters.q, page: state.page === 1 ? undefined : state.page, sort: state.sort === defaultSort ? undefined : state.sort }, minAndMaxPrice);
                            return qs_1.default.stringify(filteredState, {
                                addQueryPrefix: true,
                                format: 'RFC1738',
                                sort: sortAlphabeticalWithQFirst,
                            });
                        },
                    },
                };
                var QueryParamComponent = function (props) { return (react_1.default.createElement("div", null,
                    react_1.default.createElement("div", { "data-testid": "max_price" }, props.urlState.max_price),
                    react_1.default.createElement("div", { "data-testid": "min_price" }, props.urlState.min_price),
                    react_1.default.createElement("div", { "data-testid": "page" }, props.urlState.page),
                    react_1.default.createElement("div", { "data-testid": "sort" }, props.urlState.sort),
                    react_1.default.createElement("div", { "data-testid": "q" }, props.urlState.q))); };
                var UrlConnectedControls = withUrlState_1.withUrlState(function () { return defaultQueryParameters; }, config)(QueryParamComponent);
                var wrapper = effectfulRender(react_1.default.createElement(UrlConnectedControls, null));
                expect(testHistory.location.search).toEqual('?q=Winchester');
                expect(wrapper.getByTestId('max_price').textContent).toBe('');
                expect(wrapper.getByTestId('min_price').textContent).toBe('');
                expect(wrapper.getByTestId('page').textContent).toBe('1');
                expect(wrapper.getByTestId('q').textContent).toBe('Winchester');
                expect(wrapper.getByTestId('sort').textContent).toBe('BEST_MATCH');
                testHistory.replace(__assign({}, testHistory.location, { search: config.serialisation.stringify({
                        max_price: 30,
                        min_price: 20,
                        page: 3,
                        sort: 'NEARBY',
                    }) }));
                expect(testHistory.location.search).toEqual('?max_price=30&min_price=20&page=3&q=Winchester&sort=NEARBY');
                expect(wrapper.getByTestId('max_price').textContent).toBe('30');
                expect(wrapper.getByTestId('min_price').textContent).toBe('20');
                expect(wrapper.getByTestId('page').textContent).toBe('3');
                expect(wrapper.getByTestId('q').textContent).toBe('Winchester');
                expect(wrapper.getByTestId('sort').textContent).toBe('NEARBY');
            });
        });
    });
    describe('html5HistoryAdapter', function () {
        var listener = function () { }; // tslint:disable-line
        var addTemp = window.addEventListener;
        var removeTemp = window.removeEventListener;
        var dispatchTemp = window.dispatchEvent;
        var historyPushTemp = window.history.pushState;
        var historyReplaceTemp = window.history.replaceState;
        beforeEach(function () {
            window.addEventListener = jest.fn();
            window.dispatchEvent = jest.fn();
            window.removeEventListener = jest.fn();
            window.history.pushState = jest.fn();
            window.history.replaceState = jest.fn();
        });
        afterEach(function () {
            window.addEventListener = addTemp;
            window.dispatchEvent = dispatchTemp;
            window.removeEventListener = removeTemp;
            window.history.pushState = historyPushTemp;
            window.history.replaceState = historyReplaceTemp;
        });
        it("registers itself as an event listener of 'popstate'", function () {
            withUrlState_1.html5HistoryAdapter.listen(listener);
            expect(window.addEventListener).toHaveBeenCalledWith('popstate', listener);
        });
        it("returns a callback which will remove itself as an event listener of 'popstate'", function () {
            var unsubscribe = withUrlState_1.html5HistoryAdapter.listen(listener);
            unsubscribe();
            expect(window.removeEventListener).toHaveBeenCalledWith('popstate', listener);
        });
        it("defers to the 'history' global when pushing an event", function () {
            withUrlState_1.html5HistoryAdapter.listen(listener);
            withUrlState_1.html5HistoryAdapter.push({ search: 'foo=bar' });
            expect(window.history.pushState).toHaveBeenCalled();
            expect(window.dispatchEvent).toHaveBeenCalled();
        });
        it("defers to the 'history' global when replacing an event", function () {
            withUrlState_1.html5HistoryAdapter.listen(listener);
            withUrlState_1.html5HistoryAdapter.replace({ search: 'foo=bar' });
            expect(window.history.replaceState).toHaveBeenCalled();
            expect(window.dispatchEvent).toHaveBeenCalled();
        });
    });
});
